--
-- PDA
-- This is the script for new PDA and new extra Sites
--
-- M@D Author  Headshot XXL
-- M@D date 29.08.2010
--
-- > Copyright (C) Headshot XXL - www.planet-ls.de < --


print("New PDA loaded")


MissionStats.PDAScreens = {};
MissionStats.firstRun = true;


local oldMissionStatsDelete = MissionStats.delete;
MissionStats.delete = function(self)
	oldMissionStatsDelete(self);
	MissionStats.PDAScreens = {};
end;

MissionStats.mouseEvent = function(self, posX, posY, isDown, isUp, button)
	
	if self.showPDA then
		self.PDAScreens[self.screen]:mouseEvent(self, posX, posY, isDown, isUp, button);
	end;
end;

MissionStats.keyEvent = function(self, unicode, sym, modifier, isDown)
	
	if self.showPDA then
		self.PDAScreens[self.screen]:keyEvent(self, unicode, sym, modifier, isDown);
	end;
end;


MissionStats.update = function(self, dt)
	
	if self.firstRun then
		for i=1, table.getn(self.PDAScreens) do
			self.PDAScreens[i]:load(self);
		end;
		self.firstRun = false;
	end;


    if InputBinding.hasEvent(InputBinding.TOGGLE_PDA_ZOOM) then
        self.isMapZoomed = not self.isMapZoomed;
    end;

    local dtMinutes = dt/(1000*60);
    self.playTime = self.playTime + dtMinutes;
    self.playTimeSession = self.playTimeSession + dtMinutes;

    if InputBinding.hasEvent(InputBinding.TOGGLE_PDA) then
        playSample(self.pdaBeepSound, 1, 0.3, 0);

        if self.showPDA then
            if self.screen == table.getn(self.PDAScreens) then
                self.showPDA = false;
                self.screen = 1;
            else
                self.screen = self.screen + 1;
            end;
        else
            self.showPDA = true;
            self.screen = 1;
        end;
    end;
	
	if self.showPDA then
		self.PDAScreens[self.screen]:update(self, dt);
	end;
	
	--print("pda screen- " ..self.PDAScreens[1]);
	
end;

MissionStats.draw = function(self)

    if self.showPDA then
        -- render "desktop" background of pda first
        self.hudPDABackgroundOverlay:render();

        self.PDAScreens[self.screen]:draw(self); -- screens

        -- the pda's frame is rendered last so it covers any overlapping display elements
        self.hudPDAFrameOverlay:render();

        -- render the title at the pda display's top
        setTextBold(true);
        setTextColor(0,0,0,1);
        renderText(self.pdaTitleX, self.pdaTitleY - 0.002, self.pdaTitleTextSize, self.PDAScreens[self.screen].title);
        setTextColor(1,1,1,1);
        renderText(self.pdaTitleX, self.pdaTitleY, self.pdaTitleTextSize, self.PDAScreens[self.screen].title);

        -- alpha for all blinking hotspots
        MissionStats.alpha = MissionStats.alpha + MissionStats.alphaInc;
        if MissionStats.alpha > 1 then
            MissionStats.alphaInc = - MissionStats.alphaInc;
            MissionStats.alpha = 1;
        elseif MissionStats.alpha < 0 then
            MissionStats.alphaInc = - MissionStats.alphaInc;
            MissionStats.alpha = 0;
        end;
    end;

end;